var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();

var Main =
{
    selectedThumbIndex:1,
    timeOutHandle:0,
    selectedVideo : 0,
    mode : 0,
    mute : 0,
    
    UP : 0,
    DOWN : 1,
    LEFT : 2,
    RIGHT: 3,
    
    RIGA: 1,
    COLONNA:1,
    PAGINA:1,

    WINDOW : 0,
    FULLSCREEN : 1,
    
    NMUTE : 0,
    YMUTE : 1
}

Main.onLoad = function()
{
    if ( Player.init() && Audio.init() && Display.init() && Server.init() )
    {
        Display.setVolume( Audio.getVolume() );
        Display.setTime(0);
        
        Player.stopCallback = function()
        {
            //Return to windowed mode when video is stopped
             //   (by choice or when it reaches the end) 
            Main.setWindowMode();
        }


        // Start retrieving data from server
        Server.dataReceivedCallback = function()
            {
                // Use video information when it has arrived 
                
                Display.setVideoListPosition(this.selectedVideo, Main.PAGINA);

                Main.updateCurrentVideo();
            }
        Server.fetchVideoList(); // Request video information from server 

       
        // Enable key event processing
        this.enableKeys();

        widgetAPI.sendReadyEvent();    
        alert("ok");
    }
    else
    {
       alert("Failed to initialise");
    }
    
}

Main.onUnload = function()
{
    Player.deinit();
}

Main.updateCurrentVideo = function(move)
{
    
    Display.setVideoListPosition(this.selectedVideo,Main.PAGINA);

    Display.setDescription( Data.getVideoDescription(this.selectedVideo));

    this.timeOutHandle=setTimeout("Main.SetNextThumbnail()",2000);
 
    //Player.setVideoURL( Data.getVideoURL(this.selectedVideo) );

}

Main.enableKeys = function()
{
    document.getElementById("anchor").focus();
}

Main.keyDown = function()
{
    var keyCode = event.keyCode;
    alert("Key pressed: " + keyCode);
    clearTimeout(this.timeOutHandle);
    
    this.RIGA= Math.floor(this.selectedVideo/3)+1;
    this.COLONNA= (this.selectedVideo % 3)+1;
    this.PAGINA=Math.floor((this.RIGA-1)/3) +1;
    alert("Pagina=" + this.PAGINA);
    alert("Riga=" + this.RIGA);
    alert("Colonna=" + this.COLONNA);
    
    switch(keyCode)
    {
        case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
            alert("RETURN");
            Player.stopVideo();
            widgetAPI.sendReturnEvent(); 
            break;    
            break;
    
        case tvKey.KEY_PLAY:
            alert("PLAY");
            this.handlePlayKey();
            break;
            
        case tvKey.KEY_STOP:
            alert("STOP");
            Player.stopVideo();
            break;
            
        case tvKey.KEY_PAUSE:
            alert("PAUSE");
            this.handlePauseKey();
            break;
            
        case tvKey.KEY_FF:
            alert("FF");
            if(Player.getState() != Player.PAUSED)
                Player.skipForwardVideo();
            break;
        
        case tvKey.KEY_RW:
            alert("RW");
            if(Player.getState() != Player.PAUSED)
                Player.skipBackwardVideo();
            break;

        case tvKey.KEY_VOL_UP:
        case tvKey.KEY_PANEL_VOL_UP:
            alert("VOL_UP");
            if(this.mute == 0)
                Audio.setRelativeVolume(0);
            break;
            
        case tvKey.KEY_VOL_DOWN:
        case tvKey.KEY_PANEL_VOL_DOWN:
            alert("VOL_DOWN");
            if(this.mute == 0)
                Audio.setRelativeVolume(1);
            break;      
     
        case tvKey.KEY_RIGHT:
        
            alert("RIGHT");
            
            if ((this.COLONNA==3)) 
            this.selectedVideo = this.selectedVideo - 2;
            else
            this.selectedVideo =  this.selectedVideo +1;
            
            if (this.selectedVideo==Data.getVideoCount())
            this.selectedVideo =this.selectedVideo -1;
            
            alert("selectedVideo=" + this.selectedVideo);            
            this.updateCurrentVideo(this.RIGHT);
    
            break;

        case tvKey.KEY_LEFT:
        
            alert("LEFT");
            
            if ((this.COLONNA==1)) 
            this.selectedVideo = this.selectedVideo + 2;
            else
            this.selectedVideo =  this.selectedVideo -1;
            
            if (this.selectedVideo < 0)
            this.selectedVideo = 0;
            
            if (this.selectedVideo > (Data.getVideoCount() - 1))
            this.selectedVideo =Data.getVideoCount()-1;
            
            alert("selectedVideo=" + this.selectedVideo);            
            this.updateCurrentVideo(this.LEFT);
    
            break;
            
        case tvKey.KEY_UP:
        
            alert("UP");
            
            if ( this.RIGA>1 )
            this.selectedVideo =  this.selectedVideo - 3 ;   
            
            alert("selectedVideo=" + this.selectedVideo);

            this.RIGA= Math.floor(this.selectedVideo/3)+1;
            this.COLONNA= (this.selectedVideo % 3)+1;
            this.PAGINA=Math.floor((this.RIGA-1)/3) +1;
            alert("Pagina=" + this.PAGINA);
            alert("Riga=" + this.RIGA);
            alert("Colonna=" + this.COLONNA);

            this.updateCurrentVideo(this.UP);
    
            break;

        case tvKey.KEY_DOWN:

            alert("DOWN");
            if ( this.RIGA <  Data.getVideoCount()/3)
            this.selectedVideo =  this.selectedVideo +3;   
            
            if ( this.selectedVideo > (Data.getVideoCount() - 1))
            this.selectedVideo = this.selectedVideo-3;
            
            alert("selectedVideo=" + this.selectedVideo);

            this.RIGA= Math.floor(this.selectedVideo/3)+1;
            this.COLONNA= (this.selectedVideo % 3)+1;
            this.PAGINA=Math.floor((this.RIGA-1)/3) +1;
            alert("Pagina=" + this.PAGINA);
            alert("Riga=" + this.RIGA);
            alert("Colonna=" + this.COLONNA);

            this.updateCurrentVideo(this.DOWN);
    
            break;

        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
            alert("ENTER");
            this.toggleMode();
            break;
        
        case tvKey.KEY_MUTE:
            alert("MUTE");
            this.muteMode();
            break;
            
        default:
            alert("Unhandled key");
            break;
    }
}

Main.handlePlayKey = function()
{
    switch ( Player.getState() )
    {
        case Player.STOPPED:
            Player.setVideoURL( Data.getVideoURL(this.selectedVideo) );
            Player.playVideo();
            break;
            
        case Player.PAUSED:
            Player.resumeVideo();
            break;
            
        default:
            alert("Ignoring play key, not in correct state");
            
            break;
    }
}

Main.handlePauseKey = function()
{
    switch ( Player.getState() )
    {
        case Player.PLAYING:
            Player.pauseVideo();
            break;
        
        default:
            alert("Ignoring pause key, not in correct state");
            break;
    }
}

Main.selectNextVideo = function(right)
{
    //Player.stopVideo();
    
    this.selectedVideo = (this.selectedVideo + 1) % Data.getVideoCount();

    this.updateCurrentVideo(right);
}

Main.selectPreviousVideo = function(up)
{
    Player.stopVideo();
    
    if (--this.selectedVideo < 0)
    {
        this.selectedVideo += Data.getVideoCount();
    }

    this.updateCurrentVideo(up);
}

Main.setFullScreenMode = function()
{
    if (this.mode != this.FULLSCREEN)
    {
        Display.hide();
        
        Player.setFullscreen();
        
        this.mode = this.FULLSCREEN;
    }
}

Main.setWindowMode = function()
{
    if (this.mode != this.WINDOW)
    {
        Display.show();
        
        Player.setWindow();
        
        this.mode = this.WINDOW;
    }
}

Main.toggleMode = function()
{
    if(Player.getState() == Player.PAUSED)
    {
        Player.resumeVideo();
     }
    switch (this.mode)
    {
        case this.WINDOW:
            this.setFullScreenMode();
            break;
            
        case this.FULLSCREEN:
            this.setWindowMode();
            break;
            
        default:
            alert("ERROR: unexpected mode in toggleMode");
            break;
    }
}


Main.setMuteMode = function()
{
    if (this.mute != this.YMUTE)
    {
        var volumeElement = document.getElementById("volumeInfo");
        //Audio.plugin.SetSystemMute(true);
        Audio.plugin.SetUserMute(true);
        document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/muteBar.png)";
        document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/mute.png)";
        widgetAPI.putInnerHTML(volumeElement, "MUTE");
        this.mute = this.YMUTE;
    }
}

Main.noMuteMode = function()
{
    if (this.mute != this.NMUTE)
    {
        Audio.plugin.SetUserMute(false); 
        document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/volumeBar.png)";
        document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/volume.png)";
        Display.setVolume( Audio.getVolume() );
        this.mute = this.NMUTE;
    }
}

Main.muteMode = function()
{
    switch (this.mute)
    {
        case this.NMUTE:
            this.setMuteMode();
            break;
            
        case this.YMUTE:
            this.noMuteMode();
            break;
            
        default:
            alert("ERROR: unexpected mode in muteMode");
            break;
    }
}
Main.SetNextThumbnail=function()
{
        alert("Main.SetNextThumbnail");
        var strThumb=Data.videoThumbs[Main.selectedVideo];
        Main.selectedThumbIndex=Main.selectedThumbIndex+1;
        if (Main.selectedThumbIndex>8)
            Main.selectedThumbIndex=1;
        alert("selectedThumbIndex="+Main.selectedThumbIndex);
        
        alert("strThumb="+strThumb);
        var tmpStrThumb;
        var SlashPos;
        var tmpVideoNumber;
        if (strThumb.slice(-16)=="_extra_large.jpg")
        {
        //fai un tipo di conversione
        //dove
        //http://ss-3.youporn.com/screenshot/58/50/screenshot                               /585052  _extra           _large.jpg
        //deve diventare
        SlashPos= strThumb.lastIndexOf('/');
        alert ("SlashPos=" + SlashPos);
        tmpStrThumb=strThumb.slice(0,-(strThumb.length-SlashPos)) ;
        alert ("tmpStrThumb=" + tmpStrThumb);
        tmpVideoNumber=strThumb.slice(SlashPos+1,-16) ;
        alert ("tmpVideoNumber=" + tmpVideoNumber);
         tmpStrThumb=tmpStrThumb + "_multiple/" + tmpVideoNumber + "/" + tmpVideoNumber + "_multiple_" + Main.selectedThumbIndex + "_large.jpg"  ;
        alert ("tmpStrThumb=" + tmpStrThumb);
        
        //http://ss-3.youporn.com/screenshot/58/50/screenshot _multiple/585052/585052  _multiple_1 _large.jpg
         //quindi:trova l'ultimo slash
         
         //estrai parte iniziale
         //estrai parte numerica tra / e _
         //componi link
         
         }
        else if (strThumb.slice(-1)=="/")
        {
        //aggiungi numero.jpg
        //affinchè funzioani, anche la pagina php deve essere aggiornata.
        tmpStrThumb=strThumb + Main.selectedThumbIndex + ".jpg";
        }
        else if (strThumb.indexOf("single_160x120")>1)
         {
            var singlePosIndex=strThumb.indexOf("single_160x120");
            alert("singlePosIndex=" + singlePosIndex);
            //estraiamo il numero
            SlashPos= strThumb.lastIndexOf('/');
            alert("SlashPos=" + SlashPos);
            var DotPos=strThumb.lastIndexOf('.');
            alert("DotPos=" + DotPos);
            tmpVideoNumber=strThumb.slice(SlashPos+1,DotPos) ;
            alert("tmpVideoNumber=" + tmpVideoNumber);
            var LastPartAddress=  "/" +tmpVideoNumber + "/" + Main.selectedThumbIndex + ".jpg";
            
            var tmpSubfoldervar=tmpVideoNumber.slice(0,-2);
            alert("tmpSubfoldervar1="+tmpSubfoldervar);

            while (tmpSubfoldervar.length>0) 
           { 
            if (tmpSubfoldervar.length==1) 
            {   
                tmpSubfoldervar="0" +tmpSubfoldervar; 
            };
            alert("tmpSubfoldervar2="+tmpSubfoldervar);
            
            
            LastPartAddress=  "/" + tmpSubfoldervar.slice(-2) + LastPartAddress;
            
            tmpSubfoldervar=tmpSubfoldervar.slice(0,-2);
            alert("tmpSubfoldervar3="+tmpSubfoldervar);
            
            };
            alert("LastPartAddress="+LastPartAddress);
             tmpStrThumb=strThumb.slice(0,singlePosIndex) + "multiple_160x120" + LastPartAddress;
            alert("tmpStrThumb=" + tmpStrThumb);
  
                /*http://ss-2.youporn.com/thumbnail/ single_160x120/4684.jpg					
                http://ss-2.youporn.com/thumbnail/ multiple_160x120/46/4684

                http://ss-2.youporn.com/thumbnail/single_160x120/71797.jpg
                http://ss-2.youporn.com/thumbnail/multiple_160x120/07/17/71797

                http://ss-1.youporn.com/thumbnail/single_160x120/84415.jpg
                http://ss-1.youporn.com/thumbnail/multiple_160x120/08/44/84415
                        
                http://ss-3.youporn.com/thumbnail/single_160x120/84482.jpg
                http://ss-3.youporn.com/thumbnail/multiple_160x120/08/44/84482
                */
        }
        else
        {
        tmpStrThumb= strThumb ; //"http://ss-1.youporn.com/thumbnail/single_160x120/6983.jpg";
        }
        
        listHTML= '<img src=" ' + tmpStrThumb + '" border=0 width="98" height="98" >';
        alert("Main.selectedVideo="+Main.selectedVideo);
        
        alert("(Main.PAGINA-1)*9)=" + (Main.PAGINA-1)*9);
        widgetAPI.putInnerHTML(document.getElementById("video"+(Main.selectedVideo-((Main.PAGINA-1)*9))), listHTML);

        
    this.timeOutHandle=setTimeout("Main.SetNextThumbnail()",2000);

}